### This script takes an initial vocabulary created by LPR_ngram_seg.py
### and breaks it down to a (generally much smaller) final vocabulary
### It first calculates some POS statistics that are used to normalize
### the effects, and then proceeds through the entire set of n-grams,
### starting with the longest, which are further ranked by frequency (low
### frequency first)
### see paper for more details about exact logic.


import gc
import copy
import math
import cPickle
import sys
from pos_helper import matches_gap_en,matches_gap_fr
from multi_helper import *
from corpus_reader import read_sentence_from_corpus
from LPR_helper import *
gc.disable()

def get_best(predictor_dict):
    total = 0
    for i in predictor_dict:
        total += predictor_dict[i][-1][0]
    return total

def get_best_over_range(start,end,predictor_dict):
    total = 0
    for i in range(start,end):
        total += predictor_dict[i][-1][0]
    return total

def get_best_over_range_limit(start,end,predictor_dict):
    total = 0
    breaks = (start,end)
    for i in range(start,end):
        j = -1
        while True:
            if compatible_with_breaks(predictor_dict[i][j][-1],breaks):
                total += predictor_dict[i][j][0]
                break
            j -= 1
    return total

def get_best_over_range_limit_skip(begin_skip,end_skip,predictor_dict):
    total = 0
    for i in predictor_dict:
        if begin_skip <= i < end_skip:
            continue
        j = -1
        while True:
            if (len(predictor_dict[i][j][-1]) == 4 and predictor_dict[i][j][-1][2] <= begin_skip and predictor_dict[i][j][-1][3] >= end_skip) or predictor_dict[i][j][-1][1] <= begin_skip or predictor_dict[i][j][-1][0] >= end_skip:
                total += predictor_dict[i][j][0]
                break 
                
            j -= 1
    return total


def decompose_vocabulary(counts_dict,best_pos_dict,pos_counts,pos_type_dict,cond_prob_dict,skip_counts_dict,skip_best_pos_dict,skip_pos_counts,skip_pos_type_dict,skip_cond_prob_dict,unigram_dict,freq_cutoff,POS_id_dict):
    
    for k in range(options.n - 1,0,-1):
        broke_count = 0
        not_broke_count = 0
        if not options.silent:
            print "%d-grams" % (k + 1)
        sorted_counts = []
        for ID in counts_dict:
            sorted_counts.append((counts_dict[ID],ID,False))
        for ID in skip_counts_dict:
            sorted_counts.append((skip_counts_dict[ID],ID,True))
        sorted_counts.sort()
        for count, ID, is_skip in sorted_counts:

                words = decode_id(ID)
                if is_skip:
                    skip_point = words[0] + 1
                    words = words[1:]
                
                
                if len(words) == k + 1:
                    #print ID
                    print [id_dict[word] for word in words]
                    print skip_point
                    #print count
                    if is_skip:
                        pos = decode_id(skip_best_pos_dict[ID])[1:]
                    else:
                        pos = decode_id(best_pos_dict[ID])

                    org_pos = [POS_id_dict[thing] for thing in pos]
                    print org_pos
                    if is_skip:
                        start_count = skip_counts_dict[ID]
                        
                        try:
                            pos_count = math.log(skip_pos_counts[skip_best_pos_dict[ID]],2)
                            pos_types = math.log(skip_pos_type_dict[skip_best_pos_dict[ID]],2)
                        except:
                            pos_count = math.log(start_count)
                            pos_types = 0
                    else:
                        start_count = counts_dict[ID]
                        try:
                            pos_count = math.log(pos_counts[best_pos_dict[ID]],2)
                            pos_types = math.log(pos_type_dict[best_pos_dict[ID]],2)
                        except:
                            pos_count = math.log(start_count)
                            pos_types = 0
                                 

                    if start_count == 0:
                        if is_skip:
                            del skip_counts_dict[ID]
                        else:
                            del counts_dict[ID]
                        continue
                        
                    
                    skip_spans = []
                    predictor_dict = {}
                    if not is_skip:
                        for i in range(1, len(words) - 1):
                            for j in range(i+1,len(words)):
                                if matches_gap(org_pos, i, j):
                                    skip_spans.append((0,len(words),i,j))
                    for i in range(len(words)):
                        if is_skip:
                            predictor_dict[i] = get_ranking_of_predictors(words, i, [(0,skip_point), (skip_point,len(words))],cond_prob_dict,[(0,len(words),skip_point,skip_point)],skip_cond_prob_dict)
                        else:
                            predictor_dict[i] = get_ranking_of_predictors(words, i, [[0,len(words)]],cond_prob_dict,skip_spans,skip_cond_prob_dict)


                    best_score = None
                    break_sofar = None
                    best_score_pronoun = None
                    break_sofar_pronoun = None
                    has_pos_pred = False
                    over_cutoff = False
                    candidates = []
                    for skip_span in skip_spans:
                        candidates.append(((skip_span[2],skip_span[3]), True))
                    for i in range(1,len(words)):
                        candidates.append((i, False))

                    for best_break, did_skip in candidates:
                        count = start_count
                        pronoun_break = False

                        if not is_skip:

                            if did_skip:
                                sub_ngram1 = get_multi_id_range_skip(words,0,best_break[0],best_break[1],len(words))
                            else:        
                                sub_ngram1 = get_multi_id_range(words,0,best_break)
                            try:
                                if best_break == 1:
                                    sub_ngram1_count = unigram_dict[get_multi_id_range_both(words,pos,0,1)]
                                elif did_skip:
                                    sub_ngram1_count = skip_counts_dict[sub_ngram1]
                                else:
                                    sub_ngram1_count = counts_dict[sub_ngram1]
                            except:
                                sub_ngram1_count = -1
                            


                            if did_skip:
                                sub_ngram2 = get_multi_id_range(words,best_break[0],best_break[1])
                            else:
                                sub_ngram2 = get_multi_id_range(words,best_break,len(words))

                            try:
                                if did_skip:
                                    if best_break[1] - best_break[0] == 1:
                                        sub_ngram2_count = unigram_dict[get_multi_id_range_both(words,pos,best_break[0],best_break[1])]
                                    else:
                                        sub_ngram2_count = counts_dict[sub_ngram2]
                                elif best_break == len(words) - 1:
                                    sub_ngram2_count = unigram_dict[get_multi_id_range_both(words,pos,best_break,len(words))]
                                else:
                                    sub_ngram2_count = counts_dict[sub_ngram2]
                            except:
                                sub_ngram2_count = -1
                    
                            

                            if did_skip:
                                sub_ngram1_pos = get_multi_id_range_skip(pos,0,best_break[0],best_break[1],len(words))
                                try:
                                    sub_ngram1_pos_count = math.log(skip_pos_counts[sub_ngram1_pos],2)
                                except:
                                    if sub_ngram1_count > 0:
                                        sub_ngram1_pos_count = math.log(sub_ngram1_count)
                                    else:
                                        sub_ngram1_pos_count = 0
                                try:
                                    sub_ngram1_pos_types = math.log(skip_pos_type_dict[sub_ngram1_pos],2)
                                except:
                                    sub_ngram1_pos_types  = 0

                            else:
                                sub_ngram1_pos = get_multi_id_range(pos,0,best_break)
                                try:
                                    sub_ngram1_pos_count = math.log(pos_counts[sub_ngram1_pos],2)
                                except:
                                    if sub_ngram1_count > 0:
                                        sub_ngram1_pos_count = math.log(sub_ngram1_count)
                                    else:
                                        sub_ngram1_pos_count = 0
                                    sub_ngram1_pos_count = 0
                                try:
                                    sub_ngram1_pos_types = math.log(pos_type_dict[sub_ngram1_pos],2)
                                except:
                                    sub_ngram1_pos_types  = 0

                                
                            
                            if did_skip:
                                sub_ngram2_pos = get_multi_id_range(pos,best_break[0],best_break[1])
                            else:
                                sub_ngram2_pos = get_multi_id_range(pos,best_break,len(pos))
                            try:
                                sub_ngram2_pos_count =  math.log(pos_counts[sub_ngram2_pos],2)
                            except:
                                if sub_ngram2_count > 0:
                                    sub_ngram2_pos_count = math.log(sub_ngram2_count)
                                else:
                                    sub_ngram2_pos_count = 0
                            try:
                                sub_ngram2_pos_types = math.log(pos_type_dict[sub_ngram2_pos],2)
                            except:
                               sub_ngram2_pos_types = 0


                            no_break_best_pred = get_best(predictor_dict)

                            if did_skip:
                                ngram1_limit_best_pred = get_best_over_range_limit_skip(best_break[0],best_break[1],predictor_dict)
                            else:
                                ngram1_limit_best_pred = get_best_over_range_limit(0,best_break,predictor_dict)

                            if did_skip:
                                ngram2_limit_best_pred = get_best_over_range_limit(best_break[0],best_break[1],predictor_dict)
                            else:
                                ngram2_limit_best_pred = get_best_over_range_limit(best_break,len(words),predictor_dict)

                        else:

                            if did_skip:
                                sub_ngram1 = get_multi_id_range_skip(words,0,best_break[0],best_break[1],len(words))
                                n1skip = True
                            else:
                                if best_break > skip_point:
                                    sub_ngram1= get_multi_id_range_skip(words,0,skip_point,skip_point,best_break)
                                    n1skip = True
                                else:
                                    sub_ngram1 = get_multi_id_range(words,0,best_break)
                                    n1skip = False

                            try:

                                if best_break == 1:
                                    sub_ngram1_count = unigram_dict[get_multi_id_range_both(words,pos,0,1)]
                                elif did_skip or best_break > skip_point:
                                    sub_ngram1_count = skip_counts_dict[sub_ngram1]
                                else:
                                    sub_ngram1_count = counts_dict[sub_ngram1]
                            except:
                                sub_ngram1_count = -1

                            if did_skip:
                                sub_ngram2 = get_multi_id_range(words,best_break[0],best_break[1])
                                n2skip = False
                            else:
                                if best_break < skip_point:
                                    sub_ngram2= get_multi_id_range_skip(words,best_break,skip_point,skip_point,len(words))
                                    n2skip = True
                                else:
                                    sub_ngram2 = get_multi_id_range(words,best_break,len(words))
                                    n2skip = False
                            try:
                                if did_skip and best_break[1] - best_break[0] == 1:
                                   sub_ngram2_count = unigram_dict[get_multi_id_range_both(words,pos,best_break[0],best_break[1])]
                                    
                                elif best_break == len(words) - 1:
                                    sub_ngram2_count = unigram_dict[get_multi_id_range_both(words,pos,best_break,len(words))]

                                elif best_break < skip_point:
                                    sub_ngram2_count = skip_counts_dict[sub_ngram2]
                               
                                else:
                                    sub_ngram2_count = counts_dict[sub_ngram2]
                            except:
                                sub_ngram2_count = -1


                            if did_skip or best_break > skip_point:
                                if did_skip:
                                    sub_ngram1_pos = get_multi_id_range_skip(pos,0,best_break[0],best_break[1],len(words))
                                else:
                                    sub_ngram1_pos = get_multi_id_range_skip(pos,0,skip_point,skip_point,best_break)
                                try:
                                    sub_ngram1_pos_count = math.log(skip_pos_counts[sub_ngram1_pos],2)
                                except:
                                    if sub_ngram1_count > 0:
                                        sub_ngram1_pos_count = math.log(sub_ngram1_count)
                                    else:
                                        sub_ngram1_pos_count = 0
                                try:
                                    sub_ngram1_pos_types = math.log(skip_pos_type_dict[sub_ngram1_pos],2)
                                except:
                                    sub_ngram1_pos_types  = 0

                            else:
                                sub_ngram1_pos = get_multi_id_range(pos,0,best_break)
                                try:
                                    sub_ngram1_pos_count = math.log(pos_counts[sub_ngram1_pos],2)
                                except:
                                    if sub_ngram1_count > 0:
                                        sub_ngram1_pos_count = math.log(sub_ngram1_count)
                                    else:
                                        sub_ngram1_pos_count = 0
                                try:
                                    sub_ngram1_pos_types = math.log(pos_type_dict[sub_ngram1_pos],2)
                                except:
                                    sub_ngram1_pos_types  = 0
                            if best_break < skip_point:
                                sub_ngram2_pos = get_multi_id_range_skip(pos,best_break,skip_point,skip_point,len(words))                   
                            elif did_skip:
                                sub_ngram2_pos = get_multi_id_range(pos,best_break[0],best_break[1])
                            else:
                                sub_ngram2_pos = get_multi_id_range(pos,best_break,len(pos))
                            if best_break < skip_point:
                                try:
                                    sub_ngram2_pos_count =  math.log(skip_pos_counts[sub_ngram2_pos],2)
                                except:
                                    if sub_ngram2_count > 0:
                                        sub_ngram2_pos_count = math.log(sub_ngram2_count)
                                    else:
                                        sub_ngram2_pos_count = 0
                            else:
                                try:
                                    sub_ngram2_pos_count =  math.log(pos_counts[sub_ngram2_pos],2)
                                except:
                                    if sub_ngram2_count > 0:
                                        sub_ngram2_pos_count = math.log(sub_ngram2_count)
                                    else:
                                        sub_ngram2_pos_count = 0
                            try:
                                if best_break < skip_point:
                                    sub_ngram2_pos_types = math.log(skip_pos_type_dict[sub_ngram2_pos],2)
                                else:
                                    sub_ngram2_pos_types = math.log(pos_type_dict[sub_ngram2_pos],2)
                            except:
                               sub_ngram2_pos_types = 0

                            no_break_best_pred = get_best(predictor_dict)
                            if did_skip:
                                ngram1_limit_best_pred = get_best_over_range_limit_skip(best_break[0],best_break[1],predictor_dict)
                            else:
                                ngram1_limit_best_pred = get_best_over_range_limit(0,best_break,predictor_dict)
                                
                            if did_skip:
                                ngram2_limit_best_pred = get_best_over_range_limit_skip(best_break[0],best_break[1],predictor_dict)
                            else:
                                ngram2_limit_best_pred = get_best_over_range_limit(best_break,len(words),predictor_dict)

                                                 

                                                

                        if sub_ngram1_count > 0 and sub_ngram2_count > 0:
                            sub_ngram1_penalty = math.log(math.log(token_count/sub_ngram1_count,2),2)

                            sub_ngram1_count = math.log(sub_ngram1_count,2)
                            sub_ngram2_count = math.log(sub_ngram2_count,2)

                            
                            try:
                                count = math.log(count,2)
                            except:
                                count = 0
                          
                        else:
                            if sub_ngram1_count <= 0:
                                sub_ngram1_count = -1
                            if sub_ngram2_count <= 0:
                                sub_ngram2_count = -1
       

                        left_side =no_break_best_pred - ngram1_limit_best_pred - ngram2_limit_best_pred
                        right_side = 0


                        if sub_ngram1_count == -1 or sub_ngram2_count == -1:
                            right_side = -9999

                        elif sub_ngram2_count > sub_ngram1_count:
                            try:
                                sub_ngram2_penalty = math.log(math.log(token_count/sub_ngram2_count,2),2)
                            except:
                                sub_ngram2_penalty =  math.log(math.log(token_count,2),2)
                            right_side += sub_ngram1_count - count -sub_ngram1_pos_count + sub_ngram1_pos_types + pos_count - pos_types + sub_ngram2_penalty 
                        else:
                            try:
                                sub_ngram1_penalty = math.log(math.log(token_count/sub_ngram1_count,2),2)
                            except:
                                sub_ngram1_penalty =  math.log(math.log(token_count,2),2)
                            
                            right_side += sub_ngram2_count - count -sub_ngram2_pos_count + sub_ngram2_pos_types + pos_count - pos_types + sub_ngram1_penalty

                        if right_side - left_side > best_score:
                            best_score = right_side - left_side

                            if is_skip and not did_skip and best_break < skip_point:
                                break_sofar = [sub_ngram2, sub_ngram1, True,start_count,right_side, left_side]
                            elif is_skip and not did_skip and best_break == skip_point:
                                break_sofar = [sub_ngram2, sub_ngram1, False,start_count,right_side, left_side]
                            else:
                                break_sofar = [sub_ngram1, sub_ngram2, (did_skip or is_skip), start_count,right_side, left_side]
            
                            if start_count >= freq_cutoff:
                                over_cutoff = True
                            if left_side > 0:
                                has_pos_pred = True

                    #print break_sofar
                    
                    if break_sofar and (not has_pos_pred or break_sofar[4] - break_sofar[5] > 0 or not over_cutoff):
                        
                        if break_sofar[2]:
                            if break_sofar[0] in skip_best_pos_dict:
                                skip_counts_dict[break_sofar[0]] = skip_counts_dict.get(break_sofar[0], 0) + start_count    

                        else:
                            if break_sofar[0] in best_pos_dict:
                                counts_dict[break_sofar[0]] = counts_dict.get(break_sofar[0], 0) + start_count

                        if break_sofar[1] in best_pos_dict:
                            counts_dict[break_sofar[1]] = counts_dict.get(break_sofar[1], 0) + start_count
                        if is_skip:
                            del skip_counts_dict[ID]
                        else:
                            del counts_dict[ID]
                        broke_count += 1
                    else:
                        not_broke_count += 1   
                        

        if not options.silent:
            print "removed"
            print broke_count
            print "preserved"
            print not_broke_count
    
    return counts_dict,skip_counts_dict


def get_pos_type_counts_all(vocab_dict,best_pos_dict,skip_vocab_dict,skip_best_pos_dict,POS_id_dict):
    pos_type_dict = {}
    pos_counts_dict = {}
    skip_pos_type_dict = {}
    skip_pos_counts_dict = {}
    for ongram in vocab_dict:
        pos = decode_id(best_pos_dict[ongram])
        words = decode_id(ongram)
        org_pos = [POS_id_dict[temp] for temp in pos]
        for i in range(len(pos)):
            for j in range(i+1,len(pos) + 1):
                multi_id = get_multi_id_range(pos,i,j)
                if multi_id not in pos_type_dict:
                    pos_type_dict[multi_id] = set()
                pos_type_dict[multi_id].add(get_multi_id_range(words,i,j))
                pos_counts_dict[multi_id] = pos_counts_dict.get(multi_id,0) + vocab_dict[ongram]

                if i > 0 and j < len(pos) and matches_gap(org_pos,i,j):
                    for m in range(0,i):
                        for n in range(j, len(pos) + 1):
                            skip_ID_pos = get_multi_id_range_skip(pos,m,i,j,n)
                            skip_ID =  get_multi_id_range_skip(words,m,i,j,n)
                            if skip_ID_pos not in skip_pos_type_dict:
                                skip_pos_type_dict[skip_ID_pos] = set()
                            skip_pos_type_dict[skip_ID_pos].add(skip_ID)
                            skip_pos_counts_dict[skip_ID_pos] = skip_pos_counts_dict.get(skip_ID_pos,0) +  vocab_dict[ongram]

    for ongram in skip_vocab_dict:
        pos = decode_id(skip_best_pos_dict[ongram])
        words =  decode_id(ongram)
        break_point = words[0] +1
        pos = pos[1:]
        words = words[1:]
        org_pos = [POS_id_dict[temp] for temp in pos]
        for i in range(break_point):
            for j in range(i + 1,break_point + 1):

                multi_id = get_multi_id_range(pos,i,j)
                if multi_id not in pos_type_dict:
                    pos_type_dict[multi_id] = set()
                pos_type_dict[multi_id].add(get_multi_id_range(words,i,j))
                pos_counts_dict[multi_id] = pos_counts_dict.get(multi_id,0) + skip_vocab_dict[ongram]
                for m in range(i + 1,j-1):
                    for n in range(m+1, j):
                        if matches_gap(org_pos,m,n):
                            skip_ID_pos = get_multi_id_range_skip(pos,i,m,n,j)
                            skip_ID =  get_multi_id_range_skip(words,i,m,n,j)
                            if skip_ID_pos not in skip_pos_type_dict:
                                skip_pos_type_dict[skip_ID_pos] = set()
                            skip_pos_type_dict[skip_ID_pos].add(skip_ID)
                            skip_pos_counts_dict[skip_ID_pos] = skip_pos_counts_dict.get(skip_ID_pos,0) +  skip_vocab_dict[ongram]

      
            for j in range(break_point,len(pos) + 1):
                multi_id = get_multi_id_range_skip(pos,i,break_point,break_point, j)
                if multi_id not in skip_pos_type_dict:
                    skip_pos_type_dict[multi_id] = set()
                skip_pos_type_dict[multi_id].add(get_multi_id_range_skip(words,i,break_point,break_point,j))
                skip_pos_counts_dict[multi_id] = skip_pos_counts_dict.get(multi_id,0) + skip_vocab_dict[ongram]

        for i in range(break_point,len(pos)):
            for j in range(i + 1, len(pos) + 1):
                multi_id = get_multi_id_range(pos,i,j)
                if multi_id not in pos_type_dict:
                    pos_type_dict[multi_id] = set()
                pos_type_dict[multi_id].add(get_multi_id_range(words,i,j))
                pos_counts_dict[multi_id] = pos_counts_dict.get(multi_id,0) + skip_vocab_dict[ongram]
                for m in range(i + 1,j-1):
                    for n in range(m+1, j):
                        if matches_gap(org_pos,m,n):
                            skip_ID_pos = get_multi_id_range_skip(pos,i,m,n,j)
                            skip_ID =  get_multi_id_range_skip(words,i,m,n,j)
                            if skip_ID_pos not in skip_pos_type_dict:
                                skip_pos_type_dict[skip_ID_pos] = set()
                            skip_pos_type_dict[skip_ID_pos].add(skip_ID)
                            skip_pos_counts_dict[skip_ID_pos] = skip_pos_counts_dict.get(skip_ID_pos,0) +  skip_vocab_dict[ongram]

                           
    for pos in pos_type_dict:
        pos_type_dict[pos] = len(pos_type_dict[pos])
    for pos in skip_pos_type_dict:
        skip_pos_type_dict[pos] = len(skip_pos_type_dict[pos])
    return pos_type_dict, pos_counts_dict, skip_pos_type_dict, skip_pos_counts_dict


f = open("temp_options.dat","rb")
options = cPickle.load(f)
f.close()
if options.lang == "en":
    matches_gap = matches_gap_en
else:
    matches_gap = matches_gap_fr


if __name__ == "__main__":
    f = open("temp_initial_vocab.dat","rb")
    vocab = cPickle.load(f)
    skip_vocab = cPickle.load(f)
    f.close()
    print len(vocab)
    print len(skip_vocab)

    f = open("temp_best_POS.dat","rb")
    best_pos_dict = cPickle.load(f)
    skip_best_pos_dict = cPickle.load(f)
    unigrams = cPickle.load(f)
    f.close()

    f = open("temp_ngrams.dat","rb")
    id_dict = cPickle.load(f)
    full_ngrams = cPickle.load(f)
    full_skipgrams = cPickle.load(f)
    token_count = cPickle.load(f)
    sentence_count = cPickle.load(f)
    POS_id_dict = cPickle.load(f)
    f.close()
    id_dict[wild_card] = "*"

    freq_cutoff = token_count/options.frequency

    f = open("temp_LPR_stats.dat", "rb")
    cond_prob_dict =  cPickle.load(f)
    skip_cond_prob_dict = cPickle.load(f)
    f.close()
    pos_type_counts, pos_counts, skip_pos_type_counts, skip_pos_counts =get_pos_type_counts_all(vocab,best_pos_dict,skip_vocab,skip_best_pos_dict,POS_id_dict)
    new_vocab, new_skip_vocab = decompose_vocabulary(vocab,best_pos_dict,pos_counts,pos_type_counts,cond_prob_dict,skip_vocab,skip_best_pos_dict,skip_pos_counts ,skip_pos_type_counts,skip_cond_prob_dict,unigrams,freq_cutoff,POS_id_dict)
    fout = open(options.output,"w")
    for ngram in new_vocab:
        if is_multi(ngram):
            fout.write(" ".join([id_dict[temp] for temp in decode_id(ngram)])  + "\t" + str(new_vocab[ngram]) + "\n")

    for ngram in new_skip_vocab:
        words = decode_id(ngram)
        skip_index = words[0]
        words = words[1:skip_index + 2] + [wild_card] + words[skip_index + 2:]
        fout.write(" ".join([id_dict[word] for word in words]) + "\t" + str(new_skip_vocab[ngram]) + "\n")
    fout.close()
