### These functions define what counts as a gap for English and French. Support
### for other languages can be added by adding a new function here, and setting
### matches_gap to point to that function in each script.


noun_pos_en = set(["PP","PDT","DT","CD","JJ","NN","NP","PP$","POS"])

noun_pos_fr = set(["PRO:IND","PRO:PER","DET:ART","NUM","ADJ","NOM","NAM","PRP","DET:POS"])

def matches_gap_en(pos,start,end):
    if end - start > 4:
        return False
    if pos[end-1] not in noun_pos_en: # quick check
        return False
    i = start
    if pos[i].startswith("PP"): #or pos[i] == "PPO":
        if end - start == 1:
            return True
        else:
            return False
    if pos[i] == "PDT":
        i += 1
        if i == end:
            return True
    if pos[i] == "DT" or pos[i] == "CD":
        i += 1
        if i == end:
            return True
    while pos[i] == "JJ":
        i += 1
        if i == end:
            return True
    while pos[i] == "NN" or pos[i] == "NP":
        i += 1
        if i == end:
            return True
    if pos[i] == "POS" or pos[i] == "PP$":
        i += 1
        if i == end:
            return True
    while pos[i] == "JJ":
        i += 1
        if i == end:
            return True
    while pos[i] == "NN":
        i += 1
        if i == end:
            return True
    return False

def matches_gap_fr(pos,start,end):
    if end - start > 4:
        return False
    if pos[end-1] not in noun_pos_fr: # quick check
        return False
    i = start
    if pos[i].startswith("PRO:PER"): #or pos[i] == "PPO":
        if end - start == 1:
            return True
        else:
            return False
    if pos[i] == "PRO:IND":
        i += 1
        if i == end:
            return True
    if pos[i] == "DET:ART" or pos[i] == "NUM":
        i += 1
        if i == end:
            return True
    if pos[i] == "ADJ":
        i += 1
        if i == end:
            return True
    while pos[i] == "NOM" or pos[i] == "NAM":
        i += 1
        if i == end:
            return True
    if pos[i] == "PRP" or pos[i] == "DET:POS" or pos[i] == "ADJ":
        i += 1
        if i == end:
            return True
    if pos[i] == "NOM" or pos[i] == "NAM":
        i += 1
        if i == end:
            return True
    return False
       
